namespace COMInterface;
//(c) Clyde Meli 2008-2009
//code offered with NO WARRANTY
// I make no warranty, guarantee or make any representations regarding the use, results of use, accuracy, 
// timeliness or completeness of any data or information relating to the code. I disclaim all warranties, express 
// or implied, and in particular, disclaim all warranties of merchantability, fitness for a particular purpose, and 
// warranties related to the code, or any service or software related thereto.
//
// I will not be liable for any direct, indirect or consequential damages or costs of any type arising out of any 
// action taken by you or others related to the code


interface

uses
  System.Drawing,
  System.Collections,
  System.Collections.Generic,
  System.Linq,
  System.Windows.Forms,
  System.ComponentModel,
  System.Reflection; //for Late Binding
  
type
  /// <summary>
  /// Summary description for MainForm.
  /// </summary>
  ObjArr = array[] of object;

ComCall = class

  private
        obj:Object;
        oParamsARR:ObjArr;
        
  public
      constructor;
      method ComInvoke(s,cmd:String;oParams:ObjArr):Object;
      method ComInvoke(cmd:String;oParams:ObjArr):Object;
      method AddObject(o:object):Object;
      method RemoveObject(o:object):Object;
      method SetParam(s1,s2:String;x:Integer):ObjArr;
      method SetParam(s:String;o:object):ObjArr;
      method SetParam(s:String):ObjArr;
      method SetParam(o:object):ObjArr;
      method SetParam(a,b,c,d,w,x,y,z:Integer):ObjArr;
      method SetParam(w,x,y,z:Integer):ObjArr;
      method SetParam(x,y,z:Integer):ObjArr;
      method SetParam(x,y:Integer):ObjArr;
      method SetParam(x:Integer):ObjArr;
      
  end;
implementation

constructor ComCall;
Begin
    obj:=new Object;        
End;

//make it easy to call COM object method
method ComCall.ComInvoke(s,cmd:String;oParams:ObjArr):Object;
Begin
  if (oParams=nil) then 
  Begin 
    obj:=nil;
    raise new ArgumentNullException('ComInvoke::oParams not initialized');
  End  
  else
  Begin
    obj := Activator.CreateInstance(System.Type.GetTypeFromProgID(s));
    obj.GetType().InvokeMember( cmd, System.Reflection.BindingFlags.InvokeMethod,  nil, obj,oParams);
    oParams:=nil;
  End;
  result:=obj;
end;

method ComCall.ComInvoke(cmd:String;oParams:ObjArr):Object;
Begin
  if (oParams=nil) then 
  Begin 
    obj:=nil;
    raise new ArgumentNullException('ComInvoke::oParams not initialized');
  End  
  else
  Begin          
    obj.GetType().InvokeMember( cmd, System.Reflection.BindingFlags.InvokeMethod,  nil, obj,oParams);
    oParams:=nil;
  End;
  result:=obj;
end;

//
// calls AddObject COM method
//
method ComCall.AddObject(o:object):Object;
Begin  
  result:=ComInvoke('AddObject',SetParam(o));    
end;

//
// calls RemoveObject COM method
//
method ComCall.RemoveObject(o:object):Object;
Begin  
  result:=ComInvoke('RemoveObject',SetParam(o));    
end;

method ComCall.SetParam(s1,s2:String;x:Integer):ObjArr;
Begin
  oParamsARR:=new object[3];
  oParamsARR[0]:=s1;  
  oParamsARR[1]:=s2;  
  oParamsARR[2]:=x;  
  result:=oParamsARR; 
end;

method ComCall.SetParam(s:String;o:object):ObjArr;
VAR
   lPsA:ObjArr;
Begin  
  lPsA:=new object[2];
  lPsA[0]:=s;  
  lPsA[1]:=o;
  result:=lPsA; 
end;

method ComCall.SetParam(s:String):ObjArr;
Begin
  oParamsARR:=new object[1];
  oParamsARR[0]:=s;  
  result:=oParamsARR; 
end;

method ComCall.SetParam(o:object):ObjArr;
Begin
  oParamsARR:=new object[1];
  oParamsARR[0]:=o;  
  result:=oParamsARR; 
end;

method ComCall.SetParam(x:Integer):ObjArr;
Begin
  oParamsARR:=new object[1];
  oParamsARR[0]:=x;  
  result:=oParamsARR; 
end;

method ComCall.SetParam(x,y:Integer):ObjArr;
Begin  
  oParamsARR:=new object[2];
  oParamsARR[0]:=x;
  oParamsARR[1]:=y;
  result:=oParamsARR;
end;

method ComCall.SetParam(x,y,z:Integer):ObjArr;
Begin  
  oParamsARR:=new object[3];
  oParamsARR[0]:=x;
  oParamsARR[1]:=y;
  oParamsARR[2]:=z;
  result:=oParamsARR;
end;

method ComCall.SetParam(w,x,y,z:Integer):ObjArr;
Begin  
  oParamsARR:=new object[4];
  oParamsARR[0]:=w;
  oParamsARR[1]:=x;
  oParamsARR[2]:=y;
  oParamsARR[3]:=z;
  result:=oParamsARR;
end;

method ComCall.SetParam(a,b,c,d,w,x,y,z:Integer):ObjArr;
Begin  
  oParamsARR:=new object[8];
  oParamsARR[0]:=a;
  oParamsARR[1]:=b;
  oParamsARR[2]:=c;
  oParamsARR[3]:=d;
  oParamsARR[4]:=w;
  oParamsARR[5]:=x;
  oParamsARR[6]:=y;
  oParamsARR[7]:=z;
  result:=oParamsARR;
end;


end.
